config/routes.rb
RightManager::Engine.routes.draw do

  resources :groups
  resources :users, only: [:index, :show, :edit, :update]
  resources :roles do
    member do
      patch :update_single_right
    end

    collection do
      get :matrix
    end
  end
  resources :rights, only: [:index, :show, :edit, :update]

  root to: "roles#index"
end

app/models/right_manager/application_record.rb
module RightManager
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/right_manager/concerns/roleable.rb
module RightManager
  module Concerns
    module Roleable

      extend ActiveSupport::Concern

      included do
        belongs_to :role, foreign_key: RightManager.role_foreign_key, class_name: RightManager::Role.name

        has_many :users_rights, class_name: RightManager::UsersRight.name, foreign_key: :user_id, dependent: :destroy
        has_many :rights, class_name: RightManager::Right.name, through: :users_rights
        accepts_nested_attributes_for :users_rights, allow_destroy: true, reject_if: :default_value

        validates :role, presence: true

      end

      class_methods do

      end

      def can?(right_name)
        right = RightManager::Right.where("LOWER(name) = ?",right_name.to_s.downcase).first
        raise RightManager::Error, "Unknown right '#{right_name}'!" unless right

        right_of_user = users_rights.where(right_id: right.id).first
        if right_of_user.blank? || right_of_user.access_level == ::RightManager::Right::ACCESS_OF_ROLE
          right_of_user = role.roles_rights.where(right_id: right.id).first
        end

        right_of_user.try(:access_level) == RightManager::Right::YES
      end

      def can!(right_name)
        raise RightManager::NoAccess, right_name unless can?(right_name)
        true
      end

      def right_manager_display_value
        raise "Abstract method ´#{__method__}´ called. Implement this instance method in your #{self.class.name}-class."
      end


      protected

      # default value is always RightManager::Right::ACCESS_OF_ROLE
      # so we save only users<-->rights access_level YES or NO combinations
      def default_value(attributes)
        exists = attributes['id'].present?
        obsolete = attributes['access_level'].to_i == RightManager::Right::ACCESS_OF_ROLE
        attributes[:_destroy] = 1 if exists && obsolete # destroy default access levels
        return (!exists && obsolete) # reject default access levels
      end

    end
  end

end

app/models/right_manager/group.rb
module RightManager
  class Group < ApplicationRecord

    has_many :rights

    validates :name, presence: true

    scope :sorted, -> {order("right_manager_groups.name ASC")}

  end
end

app/models/right_manager/right.rb
module RightManager
  class Right < ApplicationRecord

    ACCESS_OF_ROLE = 2.freeze
    YES = 1.freeze
    NO = 0.freeze

    belongs_to :group, optional: true

    has_many :roles_rights, dependent: :destroy
    has_many :roles, through: :roles_rights

    has_many :users_rights, dependent: :destroy
    has_many :users, class_name: RightManager.user_class.to_s, through: :users_rights

    validates :name, presence: true, uniqueness: true

    scope :sorted, -> {order("right_manager_rights.name ASC")}

    scope :sorted_by_group, -> {includes(:group).order('right_manager_groups.name ASC', 'right_manager_rights.name ASC')}

  end
end

app/models/right_manager/role.rb
module RightManager
  class Role < ApplicationRecord

    has_many :roles_rights, dependent: :destroy
    accepts_nested_attributes_for :roles_rights, allow_destroy: true, reject_if: :default_value


    has_many :rights, through: :roles_rights
    has_many :users, class_name: RightManager.user_class.to_s, foreign_key: RightManager.role_foreign_key

    validates :name, presence: true, uniqueness: true

    scope :sorted, -> {order("right_manager_roles.name ASC")}


    # default value is always RightManager::Right::NO
    # so we don't have to save all roles<-->rights access_level NO combinations
    def default_value(attributes)
      exists = attributes['id'].present?
      obsolete = attributes['access_level'].to_i == RightManager::Right::NO
      attributes[:_destroy] = 1 if exists && obsolete # destroy FALSE Rights
      return (!exists && obsolete) # reject FALSE Right
    end

  end
end

app/models/right_manager/roles_right.rb
module RightManager
  class RolesRight < ApplicationRecord

    belongs_to :role
    belongs_to :right

    validates :right, presence: true
    validates :role, presence: true, uniqueness: {scope: :right}

  end
end

app/models/right_manager/users_right.rb
module RightManager
  class UsersRight < ApplicationRecord

    belongs_to :user, class_name: RightManager.user_class.to_s, foreign_key: :user_id
    belongs_to :right

    validates :user, presence: true
    validates :right, presence: true, uniqueness: {scope: :user}

  end
end

app/controllers/right_manager/application_controller.rb
module RightManager
  class ApplicationController < ActionController::Base
    protect_from_forgery with: :exception
  end
end

app/controllers/right_manager/groups_controller.rb
require_dependency "right_manager/application_controller"

module RightManager
  class GroupsController < ApplicationController

    before_action :set_group, only: [:show, :edit, :update, :destroy]

    # GET /groups
    def index
      @groups = RightManager::Group.sorted.all
    end

    # GET /groups/1
    def show
    end

    # GET /groups/new
    def new
      @group = RightManager::Group.new
    end

    # GET /groups/1/edit
    def edit
    end

    # POST /groups
    def create
      @group = RightManager::Group.new(group_params)

      if @group.save
        redirect_to edit_group_url(@group), notice: I18n.t('flash.created', model: RightManager::Group.model_name.human)
      else
        render :new
      end
    end

    # PATCH/PUT /groups/1
    def update
      if @group.update(group_params)
        redirect_to edit_group_url(@group), notice: I18n.t('flash.updated', model: RightManager::Group.model_name.human)
      else
        render :edit
      end
    end

    # DELETE /groups/1
    def destroy
      @group.destroy
      redirect_to groups_url, notice: I18n.t('flash.destroyed', model: RightManager::Group.model_name.human)
    end

    private
    # Use callbacks to share common setup or constraints between actions.
    def set_group
      @group = RightManager::Group.find(params[:id])
    end

    # Only allow a trusted parameter "white list" through.
    def group_params
      params.require(:group).permit(:name)
    end
  end
  
end

app/controllers/right_manager/rights_controller.rb
require_dependency "right_manager/application_controller"

module RightManager
  class RightsController < ApplicationController
    before_action :set_right, only: [:show, :edit, :update, :destroy]

    # GET /rights
    def index
      @rights = RightManager::Right.sorted.all
    end

    # GET /rights/1
    def show
    end

    # GET /rights/new
    def new
      @right = RightManager::Right.new
    end

    # GET /rights/1/edit
    def edit
    end

    # POST /rights
    def create
      @right = RightManager::Right.new(right_params)

      if @right.save
        redirect_to edit_right_url(@right), notice: I18n.t('flash.created', model: RightManager::Right.model_name.human)
      else
        render :new
      end
    end

    # PATCH/PUT /rights/1
    def update
      if @right.update(right_params)
        redirect_to edit_right_url(@right), notice: I18n.t('flash.updated', model: RightManager::Right.model_name.human)
      else
        render :edit
      end
    end

    # DELETE /rights/1
    def destroy
      @right.destroy
      redirect_to rights_url, notice: I18n.t('flash.destroyed', model: RightManager::Right.model_name.human)
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_right
        @right = RightManager::Right.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def right_params
        params.require(:right).permit(:description, :group_id)
      end
  end
end

app/controllers/right_manager/roles_controller.rb
require_dependency "right_manager/application_controller"

module RightManager
  class RolesController < ApplicationController
    before_action :set_role, only: [:show, :edit, :update, :destroy, :update_single_right]

    # GET /roles
    def index
      @roles = RightManager::Role.sorted.all
    end

    # GET /roles/1
    def show
    end

    # GET /roles/new
    def new
      @role = RightManager::Role.new
      if params[:original_id]
        original_role = RightManager::Role.find(params[:original_id])
        @role.name = "(Copy) " + original_role.name
        @role.description = "(Copy) " + original_role.description
        original_role.roles_rights.each do |roles_right|
          @role.roles_rights.build(right_id: roles_right.right_id, access_level: roles_right.access_level)
        end
      end
    end

    # GET /roles/1/edit
    def edit
    end

    # POST /roles
    def create
      @role = RightManager::Role.new(role_params.except(:roles_rights_attributes))

      if @role.save
        #validation of RolesRight-Records fails cause the parent Role-Record doesn't exists on creation
        if @role.update(role_params)
          redirect_to edit_role_url(@role), notice: I18n.t('flash.created', model: RightManager::Role.model_name.human)
        else
          render :edit
        end
      else
        @role.assign_attributes(role_params) #reassign all params, otherwise all :roles_rights_attributes get lost
        render :new
      end
    end

    # PATCH/PUT /roles/1
    def update
      if @role.update(role_params)
        redirect_to edit_role_url(@role), notice: I18n.t('flash.updated', model: RightManager::Role.model_name.human)
      else
        render :edit
      end
    end

    # DELETE /roles/1
    def destroy
      @role.destroy
      redirect_to roles_url, notice: I18n.t('flash.destroyed', model: RightManager::Role.model_name.human)
    end

    # GET /roles/matrix
    def matrix
      @roles = RightManager::Role.includes(:rights).sorted.all
      @rights = RightManager::Right.sorted_by_group.all
    end

    # PATCH /roles/:id
    def update_single_right
      roles_right = @role.roles_rights.where(right_id: params[:right_id]).first

      #use update with nested attributes to invoke the :reject_if model validation
      if @role.update(
          roles_rights_attributes: [
              {
                  id: roles_right.try(:id),
                  access_level: params[:access_level],
                  right_id: params[:right_id]
              }
          ])
        respond_to do |format|
          format.js { head :ok}
        end
      else
        respond_to do |format|
          format.js { render plain: @role.errors.to_a.join(', ')}
        end
      end
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_role
        @role = RightManager::Role.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def role_params
        params.require(:role).permit(:name, :description, roles_rights_attributes: [ :id, :access_level, :right_id])
      end
  end
end

app/controllers/right_manager/users_controller.rb
require_dependency "right_manager/application_controller"

module RightManager
  class UsersController < ApplicationController
    before_action :set_user, only: [:show, :edit, :update, :destroy]


    # GET /users
    def index
      @users = RightManager.user_class.includes(:role).all.page(params[:page]).per(20)
    end

    # GET /users/1
    def show
    end

    # GET /users/new
    def new
      @user = RightManager.user_class.new
    end

    # GET /users/1/edit
    def edit
      unless @user.role.present?
        flash[:error] = t('view.right_manager.user_has_no_role')
        redirect_to users_path
      end
    end

    # POST /users
    def create
      @user = RightManager.user_class.new(user_params)

      if @user.save
        redirect_to edit_user_url(@user), notice: I18n.t('flash.created', model: RightManager.user_class.model_name.human)
      else
        render :new
      end
    end

    # PATCH/PUT /users/1
    def update
      if @user.update(user_params)
        redirect_to edit_user_url(@user), notice: I18n.t('flash.updated', model: RightManager.user_class.model_name.human)
      else
        render :edit
      end
    end

    # DELETE /users/1
    def destroy
      @user.destroy
      redirect_to users_url, notice: I18n.t('flash.destroyed', model: RightManager.user_class.model_name.human)
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_user
        @user = RightManager.user_class.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def user_params
        params.require(:user).permit(users_rights_attributes: [ :id, :access_level, :right_id])
      end
  end
end

app/helpers/right_manager/application_helper.rb
module RightManager
  module ApplicationHelper

    def method_missing method, *args, &block
      method.to_s.end_with?('_path', '_url') and main_app.respond_to?(method) ? main_app.send(method, *args) : super
    end

  end
end

app/views/right_manager/roles/_form.html.haml
= form_for @role, html: { class: "form-horizontal", role: "form" } do |f|
  -if @role.errors.any?
    .alert.alert-danger.alert-dismissable{role: "alert"}
      %button.close{type: "button", data: {dismiss: "alert"} }
        %span{aria: {hidden: "true"} } &times;
        %span.sr-only Close
      %h4= t("errors.template.header", count: @role.errors.count, model: @role.model_name.human)

      %ul
        - @role.errors.full_messages.each do |msg|
          %li= msg

  .form-group
    = f.label :name, class: 'col-sm-2 control-label'
    .col-sm-10
      = f.text_field :name, class: 'form-control'
  .form-group
    = f.label :description, class: 'col-sm-2 control-label'
    .col-sm-10
      = f.text_area :description, class: 'form-control'

  .form-group
    .table-responsive
      %table.table.table-striped.table-bordered.table-hover
        %thead
          %tr
            %th= RightManager::Right.human_attribute_name(:name)
            %th= RightManager::RolesRight.human_attribute_name(:access_level)

        %tbody
          - roles_rights = @role.roles_rights.to_a
          - current_group = nil

          - RightManager::Right.sorted_by_group.all.each do |right|
            - roles_right = roles_rights.map{|rr| rr if rr.right_id == right.id}.compact.first
            = hidden_field_tag "role[roles_rights_attributes][#{right.id}][id]", roles_right.try(:id)
            = hidden_field_tag "role[roles_rights_attributes][#{right.id}][right_id]", right.id
            - if current_group != right.group
              - current_group = right.group
              %tr
                %td.text-muted.text-center{colspan: 2}
                  %strong
                    = current_group.try(:name)

            %tr{class: (roles_right.try(:access_level) == RightManager::Right::YES ? "success" : "")}
              %td
                %span{"data-toggle"=>"tooltip", title: right.description}
                  = right.name
              %td= select_tag "role[roles_rights_attributes][#{right.id}][access_level]", options_for_select([[t("view.right_manager.right_value.value_1"), RightManager::Right::YES], [t("view.right_manager.right_value.value_0"), RightManager::Right::NO]], roles_right.try(:access_level) || RightManager::Right::NO), class: ['form-control', 'roles-rights-select']


  .form-group
    = f.submit class: 'btn btn-primary'

app/views/right_manager/roles/edit.html.haml
.page-header
  = link_to roles_path, class: 'btn btn-default' do
    %span.glyphicon.glyphicon-list-alt
    = t('view.right_manager.list')

  %h1= RightManager::Role.model_name.human + '-' + t('view.right_manager.edit')

= render 'form'

app/views/right_manager/roles/index.html.haml
.page-header
  = link_to new_role_path, class: 'btn btn-primary' do
    %span.glyphicon.glyphicon-plus
    = RightManager::Role.model_name.human + '-' + t('view.right_manager.new')
  = link_to matrix_roles_path, class: 'btn btn-default' do
    %span.glyphicon.glyphicon-th-large
    = RightManager::Role.model_name.human(count: 2) + '/' + RightManager::Right.model_name.human(count: 2) + '-' + t('view.right_manager.matrix')

  %h1= RightManager::Role.model_name.human(count: 2)

.table-responsive
  %table.table.table-striped.table-bordered.table-hover
    %thead
      %tr
        %th= RightManager::Role.human_attribute_name(:name)
        %th= RightManager::Role.human_attribute_name(:description)
        %th= RightManager.user_class.model_name.human(count: 2)
        %th
        %th
        %th

    %tbody
      - @roles.each do |role|
        %tr
          %td= role.name
          %td= role.description
          %td= role.users.size
          %td= link_to t('view.right_manager.edit'), edit_role_path(role)
          %td= link_to t('view.right_manager.copy'), new_role_path(original_id: role.id)
          %td= link_to t('view.right_manager.destroy'), role, data: { confirm: t('view.right_manager.confirm') }, method: :delete

app/views/right_manager/roles/matrix.html.haml
.page-header
  = link_to new_role_path, class: 'btn btn-primary' do
    %span.glyphicon.glyphicon-plus
    = RightManager::Role.model_name.human + '-' + t('view.right_manager.new')
  = link_to roles_path, class: 'btn btn-default' do
    %span.glyphicon.glyphicon-list-alt
    = t('view.right_manager.list')

  %h1= RightManager::Role.model_name.human(count: 2) + '-' + t('view.right_manager.matrix')

.table-responsive
  %table.table.table-striped.table-bordered.table-hover.table-header-rotated
    %thead
      %tr
        %th
        - @roles.each do |role|
          %th.rotate-45
            %div
              %span
                = role.name

    %tbody
      - current_group = nil
      - columns_count = @roles.size+1
      - @rights.each do |right|

        - if current_group != right.group
          - current_group = right.group
          %tr
            %td.text-muted.text-center{colspan: columns_count}
              %strong
                = current_group.try(:name)

        %tr
          %td
            %span{"data-toggle"=>"tooltip", title: right.description}
              = right.name
          - @roles.each do |role|
            - roles_right = role.roles_rights.map{|rr| rr if rr.right_id == right.id}.compact.first
            - has_access = roles_right.try(:access_level) == RightManager::Right::YES ? true : false
            - tool_tip = "#{RightManager::Role.model_name.human}: <b>#{role.name}</b><br />#{RightManager::Right.model_name.human}: <b>#{right.name.to_s}</b>".html_safe

            %td{class: (has_access ? "success" : "")}
              %div.role-matrix-cell.glyphicon{class: [(has_access ? "glyphicon-ok" : "glyphicon-minus")], "data-update-path" => update_single_right_role_path(role), "data-role-id"=> role.id, "data-right-id" => right.id, "data-access-level" => roles_right.try(:access_level), "data-toggle"=>"tooltip", title: tool_tip}

app/views/right_manager/roles/new.html.haml
.page-header
  = link_to roles_path, class: 'btn btn-default' do
    %span.glyphicon.glyphicon-list-alt
    = t('view.right_manager.list')
  %h1= RightManager::Role.model_name.human + '-' + t('view.right_manager.new')

= render 'form'

app/views/right_manager/roles/show.html.haml
.page-header
  = link_to roles_path, class: 'btn btn-default' do
    %span.glyphicon.glyphicon-list-alt
    = t('view.right_manager.list')
  = link_to edit_role_path(@role), class: 'btn btn-primary' do
    %span.glyphicon.glyphicon-pencil
    = t('view.right_manager.edit')
  %h1= RightManager::Role.model_name.human + '-' + t('view.right_manager.show')

%dl.dl-horizontal
  %dt= RightManager::Role.human_attribute_name(:name)+':'
  %dd= @role.name
  %dt= RightManager::Role.human_attribute_name(:description)+':'
  %dd= @role.description